part of 'zego_uikit_core.dart';

class ZegoUIKitCoreMessage {
  final List<ZegoInRoomMessage> _messageList = []; // uid:user

  StreamController<List<ZegoInRoomMessage>> streamControllerMessageList =
      StreamController<List<ZegoInRoomMessage>>.broadcast();

  void onIMRecvBroadcastMessage(
      String roomID, List<ZegoBroadcastMessageInfo> messageList) {
    for (ZegoBroadcastMessageInfo message in messageList) {
      _messageList.add(ZegoInRoomMessage.fromBroadcastMessage(message));
    }

    if (_messageList.length > 500) {
      _messageList.removeRange(0, _messageList.length - 500);
    }

    streamControllerMessageList.add(_messageList);
  }

  void clear() {
    _messageList.clear();
    streamControllerMessageList.add(_messageList);
  }

  void sendBroadcastMessage(String message) {
    String roomID = ZegoUIKitCore.shared.coreData.room.id;

    ZegoExpressEngine.instance
        .sendBroadcastMessage(roomID, message)
        .then((ZegoIMSendBroadcastMessageResult result) {
      _messageList.add(
        ZegoInRoomMessage(
          sender: ZegoUIKitCore.shared.coreData.localUser.toZegoUikitUser(),
          message: message,
          sendTime: DateTime.now().millisecondsSinceEpoch,
          messageID: result.messageID,
          result : result,
        ),
      );
      streamControllerMessageList.add(_messageList);
    });
  }
}
